/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_LOJA                                                     */
/* Tabela : LOJA                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_LOJA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_LOJA
GO

CREATE TRIGGER DTULTATU_LOJA
ON LOJA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'LOJA', CDFILIAL, 'CDFILIAL='+CDFILIAL+';'+'CDLOJA='+CDLOJA +';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE LOJA
      SET DTULTATULOJA = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(LOJA.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(LOJA.CDLOJA,0) = ISNULL(INSERTED.CDLOJA,0));
   END;
END;
GO

UPDATE LOJA SET DTULTATULOJA = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATULOJA IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATULOJA' and
            type = 'D')
   ALTER TABLE LOJA DROP CONSTRAINT DEFAULT_DTULTATULOJA
GO

ALTER TABLE LOJA ADD CONSTRAINT DEFAULT_DTULTATULOJA
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATULOJA
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_LOJA','5.07.005';
GO

